Bug 1288326 (CVE-2015-3196) - CVE-2015-3196 OpenSSL: Race condition handling PSK identify hint
Summary: CVE-2015-3196 OpenSSL: Race condition handling PSK identify hint
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2015-3196
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
low
low
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1288339 1288340 1288341 1288342 1290334 1291582
Blocks: 1288329 1298491 1395463
TreeView+ depends on / blocked
 
Reported: 2015-12-04 04:12 UTC by Huzaifa S. Sidhpurwala
Modified: 2019-09-29 13:40 UTC (History)
36 users (show)

Fixed In Version: openssl 1.0.0t, openssl 1.0.1p, openssl 1.0.2d
Doc Type: Bug Fix
Doc Text:
A race condition flaw, leading to a double free, was found in the way OpenSSL handled pre-shared key (PSK) identify hints. A remote attacker could use this flaw to crash a multi-threaded SSL/TLS client using OpenSSL.
Clone Of:
Environment:
Last Closed: 2019-06-08 02:46:09 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Knowledge Base (Solution) 2076883 None None None Never
Red Hat Product Errata RHSA-2015:2617 normal SHIPPED_LIVE Moderate: openssl security update 2015-12-14 09:47:00 UTC
Red Hat Product Errata RHSA-2016:2957 normal SHIPPED_LIVE Important: Red Hat JBoss Core Services Apache HTTP 2.4.23 Release 2016-12-16 03:11:19 UTC

Description Huzaifa S. Sidhpurwala 2015-12-04 04:12:40 UTC
The following was reported by OpenSSL upstream:

If PSK identity hints are received by a multi-threaded client then the values are wrongly updated in the parent SSL_CTX structure. This can
result in a race condition potentially leading to a double free of the identify hint data.

This issue was fixed in OpenSSL 1.0.2d and 1.0.1p but has not been previously listed in an OpenSSL security advisory. This issue also affects OpenSSL 1.0.0 and has not been previously fixed in an OpenSSL 1.0.0 release.

OpenSSL 1.0.2 users should upgrade to 1.0.2d
OpenSSL 1.0.1 users should upgrade to 1.0.1p
OpenSSL 1.0.0 users should upgrade to 1.0.0t

The fix for this issue can be identified in the OpenSSL git repository by commit ids 3c66a669dfc7 (1.0.2), d6be3124f228 (1.0.1) and 1392c238657e (1.0.0).

The fix was developed by Dr. Stephen Henson of the OpenSSL development team.

Comment 1 Huzaifa S. Sidhpurwala 2015-12-04 04:27:11 UTC
External References:

https://openssl.org/news/secadv/20151203.txt

Comment 4 Tomas Hoger 2015-12-10 09:21:40 UTC
Created mingw-openssl tracking bugs for this issue:

Affects: fedora-all [bug 1290334]

Comment 5 errata-xmlrpc 2015-12-14 04:47:51 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7
  Red Hat Enterprise Linux 6

Via RHSA-2015:2617 https://rhn.redhat.com/errata/RHSA-2015-2617.html

Comment 6 Fedora Update System 2015-12-14 11:51:22 UTC
openssl-1.0.1k-13.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.

Comment 8 Fedora Update System 2016-01-06 19:52:25 UTC
openssl101e-1.0.1e-5.el5 has been pushed to the Fedora EPEL 5 stable repository. If problems still persist, please make note of it in this bug report.

Comment 12 errata-xmlrpc 2016-12-15 22:15:28 UTC
This issue has been addressed in the following products:



Via RHSA-2016:2957 https://rhn.redhat.com/errata/RHSA-2016-2957.html


Note You need to log in before you can comment on or make changes to this bug.